package com.example.myapplication;


import static com.example.myapplication.SdkUtils.APP_SECRET;

import android.app.Activity;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.Color;
import android.os.Bundle;
import android.os.Handler;
import android.os.Looper;
import android.text.TextUtils;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.Toast;

import com.google.zxing.BarcodeFormat;
import com.google.zxing.EncodeHintType;
import com.google.zxing.WriterException;
import com.google.zxing.common.BitMatrix;
import com.google.zxing.qrcode.QRCodeWriter;
import com.jhk.sdk.HGameSdk;
import com.ju.api.base.ICallback;
import com.ju.component.account.entity.AccountSecretEntity;
import com.ju.component.rights.gamesdk.api.IGameActionListener;
import com.ju.component.rights.gamesdk.api.ISdkPayStatusListener;
import com.ju.component.rights.gamesdk.entity.PayParamsInfo;
import com.ju.component.rights.gamesdk.entity.UsrEntrust;

import java.util.HashMap;
import java.util.Map;

public class HiTVGameActivity extends Activity {
    private static final String TAG = "HiTVGameActivity";
    private Handler mHandler = new Handler(Looper.getMainLooper());
    private UsrEntrust mUsrEntrust;
    private EditText mMd5, mProductCode, mSdkType, mTradeNum, mPackageName, mPackagePrice, mThirdUserId, mPlatformEd;
    private ImageView mImgQr;
    private ImageView mImgQr1;
    private Bitmap mBitmap;
    private Bitmap mBitmap1;
    private int mHeight;
    private int mType = 101;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.hitvgame_main);
        mMd5 = findViewById(R.id.md5_content);
        mProductCode = findViewById(R.id.product_content);
        mSdkType = findViewById(R.id.mode_content);
        mTradeNum = findViewById(R.id.trade_content);
        mPackageName = findViewById(R.id.package_content);
        mPackagePrice = findViewById(R.id.price_content);
        mThirdUserId = findViewById(R.id.third_user_id);
        mPlatformEd = findViewById(R.id.platform_content);
        //使用功能时执行
        HGameSdk.getInstance().register(mGameActionListener);
        initBtnClickListener();
    }

    private void initBtnClickListener() {
        Button btn1 = findViewById(R.id.btn1);
        btn1.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (!HGameSdk.getInstance().isHiLogin()) {
                    HGameSdk.getInstance().toLoginPage(HiTVGameActivity.this, SdkUtils.RESULT_CODE);
                } else {
                    Toast.makeText(HiTVGameActivity.this, "已登录，不需要重复登录", Toast.LENGTH_SHORT).show();
                }
            }
        });
        Button btn2 = findViewById(R.id.btn2);
        btn2.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (HGameSdk.getInstance().isHiLogin()) {
                    HGameSdk.getInstance().toUserCenterPage(HiTVGameActivity.this);
                } else {
                    Toast.makeText(HiTVGameActivity.this, "此功能需要登录", Toast.LENGTH_SHORT).show();
                }
            }
        });

        Button btn3 = findViewById(R.id.btn3);
        btn3.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (HGameSdk.getInstance().isHiLogin()) {
                    HGameSdk.getInstance().bindPhone(HiTVGameActivity.this);
                } else {
                    Toast.makeText(HiTVGameActivity.this, "此功能需要登录", Toast.LENGTH_SHORT).show();
                }
            }
        });

        Button btn4 = findViewById(R.id.btn4);
        btn4.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (HGameSdk.getInstance().isHiLogin() || mType == 100) {
                    PayParamsInfo paramsInfo = getPayParams(1);
                    HGameSdk.getInstance().toPayPage(HiTVGameActivity.this, paramsInfo);
                } else {
                    Toast.makeText(HiTVGameActivity.this, "此功能需要登录", Toast.LENGTH_SHORT).show();
                }
            }
        });

        Button btn5 = findViewById(R.id.btn5);
        btn5.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                PayParamsInfo paramsInfo = getPayParams(3);
                HGameSdk.getInstance().getEntrustInfo(paramsInfo, new ICallback<UsrEntrust>() {
                    @Override
                    public void onSuccess(UsrEntrust entrust) {
                        Log.i(TAG, "UsrEntrust is " + entrust);
                        if (entrust != null) {
                            mUsrEntrust = entrust;
                        } else {
                            mUsrEntrust = new UsrEntrust();
                        }
                        mHandler.post(new Runnable() {
                            @Override
                            public void run() {
                                Toast.makeText(HiTVGameActivity.this, "自动续费状态查询完成，可以开始测试自动续费功能！", Toast.LENGTH_SHORT).show();
                            }
                        });
                    }

                    @Override
                    public void onFailure(int i, String s) {
                        Log.i(TAG, "EntrustResponse s is " + s);
                        mHandler.post(new Runnable() {
                            @Override
                            public void run() {
                                Toast.makeText(HiTVGameActivity.this, "自动续费状态查询异常！重试下！", Toast.LENGTH_SHORT).show();
                            }
                        });
                    }
                });
            }
        });

        Button btn6 = findViewById(R.id.btn6);
        btn6.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                PayParamsInfo paramsInfo = getPayParams(3);
                HGameSdk.getInstance().toPayPage(HiTVGameActivity.this, paramsInfo);
            }
        });
        mHeight = getResources().getDimensionPixelOffset(R.dimen.dimen_490);
        Button btn7 = findViewById(R.id.btn7);
        mImgQr = findViewById(R.id.imgQr);
        btn7.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                final PayParamsInfo paramsInfo = getPayParams(1);
                HGameSdk.getInstance().getPayUrl(paramsInfo, new ICallback<String>() {
                    @Override
                    public void onSuccess(String url) {
                        Log.i(TAG, "getPayUrl url is " + url);
                        mBitmap = getQrBitmap(url, mHeight);
                        mHandler.post(new Runnable() {
                            @Override
                            public void run() {
                                if (mBitmap != null) {
                                    mImgQr.setImageBitmap(mBitmap);
                                }
                                startPayPolling(1, paramsInfo.tradeNum, "");
                            }
                        });
                    }

                    @Override
                    public void onFailure(int i, String s) {
                        mHandler.post(new Runnable() {
                            @Override
                            public void run() {
                                Toast.makeText(HiTVGameActivity.this, "获取支付二维码失败", Toast.LENGTH_SHORT).show();
                            }
                        });
                        Log.i(TAG, "getPayUrl onFailure is " + s);
                    }
                });
            }
        });

        Button btn8 = findViewById(R.id.btn8);
        mImgQr1 = findViewById(R.id.imgQr1);
        btn8.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (mUsrEntrust == null) {
                    Toast.makeText(HiTVGameActivity.this, "请先查询自动续费状态", Toast.LENGTH_SHORT).show();
                    return;
                }
                if (mUsrEntrust.getStatus() == 3) {
                    Toast.makeText(HiTVGameActivity.this, "您已签约，不需要支付", Toast.LENGTH_SHORT).show();
                    return;
                }
                final PayParamsInfo paramsInfo = getPayParams(3);
                HGameSdk.getInstance().getPayUrl(paramsInfo, new ICallback<String>() {
                    @Override
                    public void onSuccess(String url) {
                        Log.i(TAG, "getPayUrl url is " + url);
                        mBitmap1 = getQrBitmap(url, mHeight);
                        mHandler.post(new Runnable() {
                            @Override
                            public void run() {
                                if (mBitmap1 != null) {
                                    mImgQr1.setImageBitmap(mBitmap1);
                                    startPayPolling(3, paramsInfo.tradeNum, "");
                                }
                            }
                        });
                    }

                    @Override
                    public void onFailure(int i, String s) {
                        mHandler.post(new Runnable() {
                            @Override
                            public void run() {
                                Toast.makeText(HiTVGameActivity.this, "获取自动续费二维码失败", Toast.LENGTH_SHORT).show();
                            }
                        });
                        Log.i(TAG, "getPayUrl onFailure is " + s);
                    }
                });
            }
        });

        Button btn9 = findViewById(R.id.btn9);
        btn9.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                String tradeNum = mTradeNum.getText().toString().trim();
                if (TextUtils.isEmpty(tradeNum)) {
                    Toast.makeText(HiTVGameActivity.this, "订单号为空，无法重置", Toast.LENGTH_SHORT).show();
                } else {
                    HGameSdk.getInstance().resetPayStatus(tradeNum, new ICallback() {
                        @Override
                        public void onSuccess(Object o) {
                            mHandler.post(new Runnable() {
                                @Override
                                public void run() {
                                    Toast.makeText(HiTVGameActivity.this, "重置订单完成", Toast.LENGTH_SHORT).show();
                                }
                            });
                        }

                        @Override
                        public void onFailure(int i, String s) {
                            mHandler.post(new Runnable() {
                                @Override
                                public void run() {
                                    Toast.makeText(HiTVGameActivity.this, "重置订单失败", Toast.LENGTH_SHORT).show();
                                }
                            });
                        }
                    });
                }
            }
        });
        Button sdkInit = findViewById(R.id.init_sdk);
        sdkInit.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                HGameSdk.getInstance().exit();
                String type = mSdkType.getText().toString().trim();
                if (!TextUtils.isEmpty(type) && TextUtils.isDigitsOnly(type)) {
                    mType = Integer.valueOf(type);
                }
                String productCode = mProductCode.getText().toString().trim();
                if (TextUtils.isEmpty(productCode)) {
                    if (mType == 100) {
                        productCode = SdkUtils.AUTO_PRODUCT_NUM;
                    } else {
                        productCode = SdkUtils.PRODUCT_NUM;
                    }
                }
                String md5Key = mMd5.getText().toString().trim();
                if (TextUtils.isEmpty(md5Key)) {
                    if (mType == 100) {
                        md5Key = SdkUtils.AUTO_MD5_KEY;
                    } else {
                        md5Key = SdkUtils.EDU_MD5_KEY;
                    }
                }
                String packageName = mPackageName.getText().toString().trim();
                if (TextUtils.isEmpty(packageName)) {
                    if (mType == 100) {
                        packageName = SdkUtils.AUTO_PACKAGE_NAME;
                    } else {
                        packageName = SdkUtils.PACKAGE_NAME;
                    }
                }
                //setPackageName 仅供demo测试用，正常集成不需要设置
                HGameSdk.getInstance().setPackageName(packageName);
                HGameSdk.getInstance().init(HiTVGameActivity.this, SdkUtils.APP_KEY,
                        APP_SECRET, md5Key, productCode, mType);
            }
        });
        sdkInit.requestFocus();
    }

    private void startPayPolling(int flowType, String tradeNum, String subTradeNum) {
        Toast.makeText(HiTVGameActivity.this, "开始轮询", Toast.LENGTH_SHORT).show();
        HGameSdk.getInstance().startQueryPayResult(flowType, tradeNum, subTradeNum, mSdkPayListener);
        AccountSecretEntity entity = HGameSdk.getInstance().getTokenInfo();
        String customerId = entity.customerId;
    }

    private ISdkPayStatusListener mSdkPayListener = new ISdkPayStatusListener() {
        @Override
        public void onPaySuccess(String s) {
            Log.i(TAG, "onPaySuccess");
            Toast.makeText(HiTVGameActivity.this, "支付成功", Toast.LENGTH_SHORT).show();
        }

        @Override
        public void onPayError(String s, String s1) {
            Log.i(TAG, "onPayError");
            Toast.makeText(HiTVGameActivity.this, "支付失败", Toast.LENGTH_SHORT).show();
        }

        @Override
        public void onPayMaxPollTimes(String s) {
            Log.i(TAG, "onPayMaxPollTimes");
            Toast.makeText(HiTVGameActivity.this, "最大次数,可退出支付或重新调用轮询", Toast.LENGTH_SHORT).show();
        }

        @Override
        public void onPayQRScan(String s) {
            Log.i(TAG, "onPayQRScan");
        }
    };

    private IGameActionListener mGameActionListener = new IGameActionListener() {

        @Override
        public void onDetailInfoReady(String nickName, String userIcon) {
            Toast.makeText(HiTVGameActivity.this, "onDetailInfoReady nickName is " + nickName
                    + " userIcon is " + userIcon, Toast.LENGTH_SHORT).show();
            Log.i(TAG, "onDetailInfoReady nickName is " + nickName + " userIcon is " + userIcon);
        }

        @Override
        public void onTokenInfoReady(boolean hasPermission, String message) {
            if (!hasPermission) {
                Toast.makeText(HiTVGameActivity.this, "权限校验未通过，请检查初始化得入参", Toast.LENGTH_SHORT).show();
                return;
            }
            AccountSecretEntity entity = HGameSdk.getInstance().getTokenInfo();

            if (entity != null) {
                String token = entity.token;
                String customerId = entity.customerId;
                Toast.makeText(HiTVGameActivity.this, "onTokenInfoReady token is " + token + " customerId is "
                        + customerId, Toast.LENGTH_SHORT).show();
                Log.i(TAG, "onTokenInfoReady token is " + token + " customerId is " + customerId);
            }
        }

        @Override
        public void onPayResult(int i) {
            Log.i(TAG, "onPayResult i is " + i);
        }

        @Override
        public Handler getCallbackHandler() {
            return mHandler;
        }
    };

    private PayParamsInfo getPayParams(int flowType) {
        PayParamsInfo paramsInfo = new PayParamsInfo();
        paramsInfo.appName = SdkUtils.APP_NAME;
        paramsInfo.flowType = flowType;
        paramsInfo.goodsCount = "1";
        paramsInfo.goodsName = "支付测试name";
        paramsInfo.goodsDesc = "支付测试desc";
        String platform = mPlatformEd.getText().toString();
        if (!TextUtils.isEmpty(platform)) {
            paramsInfo.platform = platform;
        } else {
            paramsInfo.platform = "";
        }

        String thirdUserId = mThirdUserId.getText().toString();
        if (TextUtils.isEmpty(thirdUserId)) {
            thirdUserId = "3656678";
        }
        paramsInfo.thirdUserId = thirdUserId;
        String price = mPackagePrice.getText().toString();
        if (TextUtils.isEmpty(price)) {
            price = "0.01";
        }
        paramsInfo.goodsPrice = price;
        paramsInfo.notifyUrl = SdkUtils.NOTIFY_URL;
        paramsInfo.body = "支付测试body";
        paramsInfo.contractDisplayAccount = "海信测试账号";
        String tradeNum = mTradeNum.getText().toString().trim();
        if (TextUtils.isEmpty(tradeNum)) {
            tradeNum = SdkUtils.TRADE_NUM;
        }
        paramsInfo.tradeNum = tradeNum;
        //如下参数，自动续费特有
        paramsInfo.planId = SdkUtils.PLAN_ID;
        paramsInfo.productNo = SdkUtils.PRODUCT_NUM;
        paramsInfo.productAvailDays = "3";
        paramsInfo.relationFlag = "0";
        //自动续费需要对以下参数赋值
        if (flowType == 3 && mUsrEntrust != null) {
            paramsInfo.status = mUsrEntrust.getStatus();
            paramsInfo.subTradeNo = "";
            if (mUsrEntrust.getStatus() == 4) {
                paramsInfo.tradeNum = mUsrEntrust.getOutParentTradeNo();
                paramsInfo.subTradeNo = paramsInfo.tradeNum;
            }
        }
        return paramsInfo;
    }

    private Bitmap getQrBitmap(String name, int height) {
        QRCodeWriter qrCodeWriter = new QRCodeWriter();
        Map<EncodeHintType, String> hints = new HashMap<>();
        hints.put(EncodeHintType.CHARACTER_SET, "utf-8");
        BitMatrix encode = null;
        try {
            encode = qrCodeWriter.encode(name, BarcodeFormat.QR_CODE, height, height, hints);
        } catch (WriterException e) {
            e.printStackTrace();
        }
        int[] colors = new int[height * height];
        for (int i = 0; i < height; i++) {
            for (int j = 0; j < height; j++) {
                if (encode.get(i, j)) {
                    colors[i * height + j] = Color.BLACK;
                } else {
                    colors[i * height + j] = Color.WHITE;
                }
            }
        }

        Bitmap bit = Bitmap.createBitmap(colors, height, height, Bitmap.Config.RGB_565);
        return bit;
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        Log.i(TAG, "onActivityResult requestCode is " + requestCode + " resultCode is " + resultCode);
        if (requestCode == SdkUtils.RESULT_CODE) {
            if (HGameSdk.getInstance().isHiLogin()) {
                Toast.makeText(HiTVGameActivity.this,
                        "登录成功", Toast.LENGTH_SHORT).show();
            } else {
                Toast.makeText(HiTVGameActivity.this,
                        "未登录或登录失败", Toast.LENGTH_SHORT).show();
            }
        }
        super.onActivityResult(requestCode, resultCode, data);
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        HGameSdk.getInstance().unregister(mGameActionListener);
        HGameSdk.getInstance().exit();
        android.os.Process.killProcess(android.os.Process.myPid());
        System.exit(0);
    }
}
